# CSC 111, Day 34
# Author: Sara Mathieson and CSC 111 class
# A program to analyze genes using classes.
# Added: assert and __str__ for printing instances.

import random

# global variable (common to put in all caps)
BASES = ["A","C","G","T"]

class RandomGene:

    def __init__(self, my_start, my_end):
        """Creates a random gene of length my_end-my_start."""
        # two instance variables for start/end
        self.start = my_start
        self.end = my_end

        # build up a random gene from A,C,G,T bases
        length = self.end - self.start
        self.sequence = ""
        for i in range(length):
            self.sequence += random.choice(BASES)

    def is_inside(self, query):
        """Check if the query position (int) is inside the gene."""
        if self.start <= query < self.end:
            return True
        else:
            return False
            
    def base(self, query):
        """Return the base (str) at the query position (int)."""
        assert self.is_inside(query) # use assert (calling a method: use self)
        index = query - self.start   # relative index
        return self.sequence[index]  # base at the query position

    def __str__(self):
        """Special way of returning a string representation of the instance."""
        str_rep = "gene: " + str(self.start) + "-" + str(self.end) + "\n"
        str_rep += self.sequence[:10] + "..." + self.sequence[-10:]
        return str_rep # very important to return, don't use calls to print(..)


def main():

    # start and end positions for a single gene
    my_start = 2934
    my_end   = 5247

    # list of positions - we want to know if they are inside the gene
    query_lst = [2384, 4928, 8374, 238, 3872, 1278, 4374, 12898, 5019]

    # use the constructor to create one gene
    gene = RandomGene(my_start, my_end)

    # before this line printed: <__main__.RandomGene object at 0x10d9ccf60>
    print(gene) # now we can print a nice representation
    print()

    # for each query, check it it's inside the gene
    for query in query_lst:
        if gene.is_inside(query):
            print(query, gene.base(query))
        else:
            print(query, "not in gene")
            
main()
